### Method

# Ggit TreeBuilder insert

#### Declaration [src]

    GgitTreeEntry*
    ggit_tree_builder_insert (
      GgitTreeBuilder* builder,
      const gchar* filename,
      GgitOId* oid,
      GgitFileMode file_mode,
      GError** error
    )

#### Description [src]

Insert a file with a given blob in the tree builder. If the tree builder already contains an entry for the given file, then this entry will be overwritten.

Note that the returned `GgitTreeEntry` is bound to the lifetime of the tree builder and cannot be used after the tree builder has been freed.

#### Parameters

`filename`

  Type: `const gchar*`

  The file name.

  The data is owned by the caller of the method.
  The value is a NUL terminated UTF-8 string.

`oid`

  Type: `GgitOId`

  The `GgitOId` of the file blob to insert.

  The data is owned by the caller of the method.

`file_mode`

  Type: `GgitFileMode`

  A `GgitFileMode`.

`error`

  Type: `GError **`

  The return location for a recoverable error.

  The argument can be `NULL`.
  If the return location is not `NULL`, then you must initialize it to a `NULL` `GError*`.
  The argument will be left initialized to `NULL` by the method if there are no errors.
  In case of error, the argument will be set to a newly allocated `GError`; the caller will take ownership of the data, and be responsible for freeing it.

#### Return value

Type: `GgitTreeEntry`

A `GgitTreeEntry` or `NULL`.

The caller of the method takes ownership of the returned data, and is responsible for freeing it.
The return value can be `NULL`.